# PhasicFlow: src/phasicFlow/types/basicTypes/numericConstants.hpp File Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

numericConstants.hpp File Reference
Include dependency graph for numericConstants.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Namespaces

| pFlow

## Functions

template<typename T >
constexpr T | largestNegative ()
template<typename T >
constexpr T | epsilonValue ()
template<typename T >
constexpr T | largestPositive ()

## Variables

const real | Pi = real(3.1415926535897932384626433832)
const real | smallValue = 1.0e-15
const real | verySmallValue = 1.0e-30
const real | largeValue = 1.0e15
const real | veryLargeValue = 1.0e30
const int32 | largestNegInt32 = largestNegative<int32>()
const int32 | largestPosInt32 = largestPositive<int32>()
const int64 | largestNegInt64 = largestNegative<int64>()
const int64 | largestPosInt64 = largestPositive<int64>()
const real | largestNegREAL = largestNegative<real>()
const real | largestPosREAL = largestPositive<real>()
const real | epsilonREAL = epsilonValue<real>()